
/*************************************************************************/
/* LOADER_IMPL.H                                                     E13 */
/*                                                                       */
/* .                                                                     */
/*************************************************************************/

#ifndef LOADER_IMPL_H
#define LOADER_IMPL_H

namespace ecg {

static int STATE_COUNT = 60;

/*************************************************************************/
/* enum TERMINALS                                                        */
/*                                                                       */
/*************************************************************************/
//enum TERMINALS {
//	TOKEN_T_WORD,				// $word
//	TOKEN_T_LITERAL,			// $literal
//	TOKEN_T_NAME,				// "#name"
//	TOKEN_T_OR,					// "|"
//	TOKEN_T_COMMA,				// ","
//	TOKEN_T_DCOMMA,				// ";"
//	TOKEN_T_IS,					// "->"
//	TOKEN_T_MULTI,				// "*"
//	TOKEN_T_MANY,				// "+"
//	TOKEN_T_FLB,				// "{"
//	TOKEN_T_FRB,				// "}"
//	TOKEN_T_LB,					// "("
//	TOKEN_T_RB,					// ")"
//	TOKEN_T_QLB,				// "["
//	TOKEN_T_QRB,				// "]"
//	TOKEN_T_BEGIN,				// "<<<"
//	TOKEN_T_END,				// ">>>"
//	TOKEN_T_EQU,				// "="
//	TOKEN_T_PREFER_SHIFT,		// "prefer_shift"
//};

/*************************************************************************/
/* enum NONTERMINALS                                                     */
/*                                                                       */
/*************************************************************************/
enum NONTERMINALS {
	TOKEN_NT_WORL,				// worl
	TOKEN_NT_DECLARATION_LIST,	// declaration_list
	TOKEN_NT_PROGRAM,			// program
	TOKEN_NT_DECLARATION,		// declaration
	TOKEN_NT_TERM_LIST,			// term_list
	TOKEN_NT_CODE_BLOCK_NE,		// code_block_ne
	TOKEN_NT_PARAMS_NE,			// params_ne
	TOKEN_NT_PARAMS,			// params
	TOKEN_NT_PARAM_LIST,		// param_list
	TOKEN_NT_CODE_BLOCK,		// code_block
	TOKEN_NT_TERM,				// term
	TOKEN_NT_RULE,				// rule
	TOKEN_NT_PREFER,			// prefer
	TOKEN_NT_RULE_OR_LIST,		// rule_or_list
	TOKEN_NT_RULE_ITEM,			// rule_item
	TOKEN_NT_ITEM_LIST,			// item_list
	TOKEN_NT_ITEM,				// item
	TOKEN_NT_PROGRAM_1,			// program_1
};

class LOADER_IMPL;

/*************************************************************************/
/* class LOADER_IMPL                                                     */
/*                                                                       */
/*************************************************************************/
class LOADER {
public:
						LOADER			(void);
	bool				Compile			(void);

private:
	AUTO<LOADER_IMPL>	compilerAuto;
};

} // namespace ecg

#endif // LOADER_IMPL_H

