
#name TAVR_COMPILER_IMPL, TAVR_COMPILER

program 		-> declaration *;

// INTERFACE
declaration		-> "interface" $word {IFACE_NAME} "{" (iface_decl *) "}"; <<< IfaceDecl >>>

// iface method
iface_decl		-> method_sign ";";						<<< IfaceMethod >>>

method_sign		: METHOD_SIGN
method_sign		-> expr $word "(" mtd_args ")";			<<< MethodSign >>>

mtd_args		: METHOD_ARGS
mtd_args		-> ;
mtd_args		-> expr $word % ",";					<<< DeclArgs >>>

// FUNCTION
declaration		-> method_sign "{" statements "}";		<<< FuncDecl >>>

statements		-> statement *;
statement		-> expr ";";							<<< StateExpr >>>

expr			: EXPR
expr			-> expr "(" expr_args ")";				<<< ExprCall >>>
expr			-> expr "." $word; 						<<< ExprDotDeref >>>

expr			-> $word;								<<< ExprName >>>
expr			-> $literal;							<<< ExprLiteral >>>

expr_args		: EXPR_LIST
expr_args		-> ;
expr_args		-> expr % ",";							<<< ExprArgList >>>

$word 			= {^\s\d\y}{^\s\y}*
$literal		= \"{^\"\n}*"

$word, $literal : string

skip = \s

preset default { +all }

cbegin  = /{*}
cend	= {*}/
cline	= //